#ifndef EZS_COUNTER_H_INCLUDED
#define EZS_COUNTER_H_INCLUDED

#include <stdint.h>

#ifdef __cplusplus
extern "C" {
#endif

/*!
 * \brief returns the current value of the system timer.
 *        One tick corresponds to 13.3 ns on the tc1796
 *        if f_STM is 75 MHz. Wraparound occurs after 57.3 s.
 */
uint32_t ezs_counter_get(void);

/*!
 * \brief This function has to be called once for ezs_counter_get()
 *        to yield meaningfull results.
 */
void ezs_counter_init(void);

#ifdef __cplusplus
}
#endif

#endif // EZS_COUNTER_H_INCLUDED
